<template>
  <crud-data-table-delete
    v-model="dialog"
    :item-being-deleted="incomeBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  >
    <template v-slot:itemBeingDelete>
      {{ $t('itemBeingDelete', { title: incomeBeingDeleted.title }) }}
    </template>
    <template v-slot:whatWillHappenWhenDeleted>
      {{ $t('whatWillHappenWhenDeleted') }}
    </template>
  </crud-data-table-delete>
</template>

<script>
  export default {
    name: 'DeleteIncomeDialog',
    data () {
      return {
        dialog: false,
        isLoading: false,
        incomeBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeleteIncome', this.onDeleteIncome)
    },
    methods: {
      onDeleteIncome (income) {
        this.incomeBeingDeleted = income
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('incomes/deleteIncome', {
          ID: this.incomeBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          deleteSuccess: 'Receita excluída com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir a receita. Por favor, tente novamente.',
          itemBeingDelete: 'Receita: {title}',
          whatWillHappenWhenDeleted: 'Todos os valores desta receita deixarão de ser considerados nos cálculos.',
        },
        'en-US': {
          deleteSuccess: 'Income successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the income. Please try again.',
          itemBeingDelete: 'Income: {title}',
          whatWillHappenWhenDeleted: 'All values of this income will no longer be considered in the calculations.',
        },
      },
    },
  }
</script>
